package SimpleServer;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class Server extends Thread 
{

	private static int PORT = 8080;
	private ServerSocket serverSocket;
	private boolean exit = false;
	
	/**
	 * Binding my socket to the specified port.
	 */
	public Server()
	{
		try 
		{
		    serverSocket = new ServerSocket(PORT);
		} 
		catch (IOException e) {
		    System.out.println("Could not bind on port: " + PORT);
		    System.exit(-1);
		}
	}
	
	/**
	 * Entry point of the thread. It is called when the Thread(server).start() is called.
	 */
	public void run() 
	{
		while(!exit)
		{
			//wait for incoming connection
			try 
			{
				Socket socket = serverSocket.accept();
				RequestWorker worker = new RequestWorker(socket);
				worker.start();
			} 
			catch (IOException e) 
			{
				System.out.println("Socket.accpet failed... continuing.");
			}
		}
	}	
	
	/**
	 * Calling this function would end the thread.
	 */
	public void shutdown()
	{
		this.exit=true;
	}
	
	/**
	 * Main entry point. No args required.
	 * @param args
	 */
	public static void main(String[] args) 
	{
		//create and start a new Server thread
		Server server = new Server();
		new Thread(server).start();
		System.out.println("Server started");
	}		
}
